/*******************************************************************************
 *  Copyright 2017 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *  
 *    http://www.apache.org/licenses/LICENSE-2.0
 *  
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.hl7282.hl7model.messages.patientadministration;

import cdac.medinfo.sdk.hl7282.baselibs.messages.Message;
import cdac.medinfo.sdk.hl7282.baselibs.segments.ACC;
import cdac.medinfo.sdk.hl7282.baselibs.segments.AL1;
import cdac.medinfo.sdk.hl7282.baselibs.segments.ARV;
import cdac.medinfo.sdk.hl7282.baselibs.segments.DB1;
import cdac.medinfo.sdk.hl7282.baselibs.segments.DG1;
import cdac.medinfo.sdk.hl7282.baselibs.segments.DRG;
import cdac.medinfo.sdk.hl7282.baselibs.segments.EVN;
import cdac.medinfo.sdk.hl7282.baselibs.segments.GT1;
import cdac.medinfo.sdk.hl7282.baselibs.segments.NK1;
import cdac.medinfo.sdk.hl7282.baselibs.segments.OBX;
import cdac.medinfo.sdk.hl7282.baselibs.segments.PD1;
import cdac.medinfo.sdk.hl7282.baselibs.segments.PDA;
import cdac.medinfo.sdk.hl7282.baselibs.segments.PID;
import cdac.medinfo.sdk.hl7282.baselibs.segments.PV1;
import cdac.medinfo.sdk.hl7282.baselibs.segments.PV2;
import cdac.medinfo.sdk.hl7282.baselibs.segments.ROL;
import cdac.medinfo.sdk.hl7282.baselibs.segments.SFT;
import cdac.medinfo.sdk.hl7282.baselibs.segments.UAC;
import cdac.medinfo.sdk.hl7282.baselibs.segments.UB2;
import cdac.medinfo.sdk.hl7282.commoninterface.IGroup;
import cdac.medinfo.sdk.hl7282.commoninterface.ISegment;
import cdac.medinfo.sdk.hl7282.commoninterface.ISingleCollection;
import cdac.medinfo.sdk.hl7282.utils.EnumSegments;
import cdac.medinfo.sdk.hl7282.utils.IMap;


/**
 * ADT_A01 - Admit/Visit Notification (Event A01).
 * This event is use for Admitted patients only.A message is sent as a result of a
 * patient undergoing the admission process which assigns the patient to a bed.  
 * <p>Represents a ADT_A01 message structure (see chapter 3.2.1). This structure contains the 
 * following elements: </p>
 * 0: MSH (Message Header Segment) <b>SINGLE_COMPULSARY</b><br>
 * 1: SFT (Software Segment) <b>MULTIPLE_OPTIONAL</b><br>
 * 2: UAC (User Authentication Credential) <b>SINGLE OPTIONAL</b><br/>
 * 3: EVN (Event Type Segment) <b>SINGLE_COMPULSARY</b><br>
 * 4: PID (Patient Identification Segment) <b>SINGLE_COMPULSARY</b><br>
 * 5: PD1 (Patient Additional Demographic Segment) <b>SINGLE_OPTIONAL</b><br>
 * 6. ARV (Access Restrictions) <b>MULTIPLE_OPTIONAL</b><br/> 
 * 7: ROL (Role Segment) <b>MULTIPLE_OPTIONAL</b><br>
 * 8: NK1 (Next of Kin / Associated Parties Segment) <b>MULTIPLE_OPTIONAL</b><br>
 * 9: PV1 (Patient Visit Segment) <b>SINGLE_COMPULSARY</b><br>
 * 10: PV2 (Patient Visit - Additional Information Segment) <b>SINGLE_OPTIONAL</b><br>
 * 11: ARV (Access Restrictions) <b>MULTIPLE_OPTIONAL</b><br/> 
 * 12: ROL (Role Segment) <b>MULTIPLE_OPTIONAL</b><br>
 * 13: DB1 (Disability Segment) <b>MULTIPLE_OPTIONAL</b><br>
 * 14: OBX (Observation/Result Segment) <b>MULTIPLE_OPTIONAL</b><br>
 * 15: AL1 (Patient Allergy Information Segment) <b>MULTIPLE_OPTIONAL</b><br>
 * 16: DG1 (Diagnosis Segment) <b>MULTIPLE_OPTIONAL</b><br>
 * 17: DRG (Diagnosis Related Group) <b>SINGLE_OPTIONAL</b><br>
 * 18: PROCEDURE (a Group of segments in ADT_A01 message) <b>MULTIPLE_OPTIONAL</b><br>
 * 19: GT1 (Guarantor Segment) <b>MULTIPLE_OPTIONAL</b><br>
 * 20: INSURANCE (a Group of segment in ADT_A01 message) <b>MULTIPLE_OPTIONAL</b><br>
 * 21: ACC (Accident Segment) <b>SINGLE_OPTIONAL</b><br>
 * 22: UB1 (UB82 Segment) <b>SINGLE_OPTIONAL</b><br>
 * 23: UB2 (UB92 Data Segment) <b>SINGLE_OPTIONAL</b><br>
 * 24: PDA (Patient Death and Autopsy Segment) <b>SINGLE_OPTIONAL</b><br>
 *This class provides mechanism to validate message against HL7 v 2.8.2 standard.
 * The class provides accessors & mutators for the elements mentioned above.
 * These elements can be easily populated & populated values can be easily retrieved.
 * The class has validate method which validates Message against HL7 v 2.8.2 standard. 
 */
public abstract class ADT_A01_Common extends Message
{
	/**
	 *  Constructs the ADT_A01 message.
	 */
	ADT_A01_Common(IMap objMessageMap, String strTriggerEvent, String strMessageCode, String strMessageStructure)
	{
		super(objMessageMap, strTriggerEvent, strMessageCode, strMessageStructure);
	}

	/**
	 * Adds Software Segment(SFT) to this message.
	 * @param objSFT Specified Software Segment(SFT)to be added in message.
	 */
	public void addSoftwareSegment(SFT objSFT)
	{
		addSegment(EnumSegments.HL7_SEG_SFT, objSFT);
	}


	/**
	 * Adds collection of Software Segment(SFT) to this message.
	 * @param objSFTSegmentCollection Collection of Software Segments to add in this message
	 */
	@SuppressWarnings("unchecked")
	public void addSoftwareSegment(ISingleCollection<SFT>  objSFTSegmentCollection)
	{
		ISingleCollection<?> objSegmentCollection =  objSFTSegmentCollection;
		addSegment(EnumSegments.HL7_SEG_SFT, (ISingleCollection<ISegment>)objSegmentCollection);
	}
	
	/**
	 * Retrieves Collection of Software Segments(SFT) present in this message.
	 * @return ISingleCollection<SFT> - Collection of Software Segments(SFT) present in this message.
	 */
	@SuppressWarnings("unchecked")
	public ISingleCollection<SFT> getSoftwareSegments()
	{
		ISingleCollection<?> objSegmentCollection = getSegment(EnumSegments.HL7_SEG_SFT);
		return (ISingleCollection<SFT>)objSegmentCollection;
	}
	
	/**
	 * Retrieves User Authentication Credential(UAC) segment present in this message
	 * @return UAC - Specified UAC Segment
	 */
	public UAC getUserAuthenticationCredentialSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_UAC);
		if(objSingleCollection != null)
			return (UAC)objSingleCollection.elementAt(0);
		return null;
	}

	/**
	 * Sets value of User Authentication Credential segment for this message,overwrites if already present.
	 * @param objUAC Specified UAC Segment
	 */
	public void setUserAuthenticationCredentialSegment(UAC objUAC)
	{
		setSegment(EnumSegments.HL7_SEG_UAC,objUAC);
	}
	
	/**
	 * Retrieves Event Type(EVN) segment present in this message
	 * @return EVN - Specified EVN Segment
	 */
	public EVN getEventTypeSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_EVN);
		if(objSingleCollection != null)
			return (EVN)objSingleCollection.elementAt(0);
		return null;
	}

	/**
	 * Sets value of Event Type segment for this message,overwrites if already present.
	 * @param objEVN Specified EVN Segment
	 */
	public void setEventTypeSegment(EVN objEVN)
	{
		setSegment(EnumSegments.HL7_SEG_EVN,objEVN);
	}

	/**
	 * Retrieves Patient Identification(PID) segment present in this message.
	 * @return PID - Specified Patient Identification Segment
	 */
	public PID getPatientIdentificationSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_PID);
		if(objSingleCollection != null)
			return (PID)objSingleCollection.elementAt(0);
		return null;
	}
	/**
	 * Sets value of PID segment for this message,overwrites if already present.
	 * @param objPID Specified PID Segment
	 */
	public void setPatientIdentificationSegment(PID objPID)
	{
		setSegment(EnumSegments.HL7_SEG_PID,objPID);
	}

	/**
	 * Retrieves Additinal Demographics segment(PD1) present in this message.
	 * @return PD1 - Specified Additinal Demographics(PD1) Segment.
	 */
	public PD1 getAdditinalDemographicsSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_PD1);
		if(objSingleCollection != null)
			return (PD1)objSingleCollection.elementAt(0);
		return null;
	}

	/**
	 * Sets value of Additinal Demographics segment(PD1) for this message,overwrites if already present.
	 * @param objPD1 Specified Additinal Demographics(PD1) Segment.
	 */
	public void setAdditinalDemographicsSegment(PD1 objPD1)
	{
		setSegment(EnumSegments.HL7_SEG_PD1,objPD1);
	}

	/**
	 * Adds Access Restrictions(ARV) to this message.
	 * @param objARV Specified Access Restrictions Segment to be added in message.
	 */
	public void addPatientIdentificationAccessRestrictionsSegment(ARV objARV)
	{
		addSegment(EnumSegments.HL7_SEG_ARV_PATIENT_IDENTIFICATION, objARV);
	}

	/**
	 * Adds collection of Access Restrictions(ARV) to this message.
	 * @param objARVSegmentCollection Collection of Access Restrictions(ARV) to add in this message
	 */
	@SuppressWarnings("unchecked")
	public void addPatientIdentificationAccessRestrictionsSegment(ISingleCollection<ARV>  objARVSegmentCollection)
	{
		ISingleCollection<?> objSegmentCollection =  objARVSegmentCollection;
		addSegment(EnumSegments.HL7_SEG_ARV_PATIENT_IDENTIFICATION, (ISingleCollection<ISegment>)objSegmentCollection);
	}

	/**
	 * Retrieves Collection of Access Restrictions(ARV) present in this message.
	 * @return ISingleCollection<ARV> - Collection of Access Restrictions(ARV) present in this message.
	 */
	@SuppressWarnings("unchecked")
	public ISingleCollection<ARV> getPatientIdentificationAccessRestrictionsSegments()
	{
		ISingleCollection<?> objSegmentCollection = getSegment(EnumSegments.HL7_SEG_ARV_PATIENT_IDENTIFICATION);
		return (ISingleCollection<ARV>)objSegmentCollection;
	}
	
	/**
	 * Adds Role Segment(ROL) to this message.
	 * @param objROL Specified Role Segment to be added in message.
	 */
	public void addPatientIdentificationRoleSegment(ROL objROL)
	{
		addSegment(EnumSegments.HL7_SEG_ROL_PATIENT_IDENTIFICATION, objROL);
	}

	/**
	 * Adds collection of Role Segments(ROL) to this message.
	 * @param objROLSegmentCollection Collection of Role Segment(ROL) to add in this message
	 */
	@SuppressWarnings("unchecked")
	public void addPatientIdentificationRoleSegment(ISingleCollection<ROL>  objROLSegmentCollection)
	{
		ISingleCollection<?> objSegmentCollection =  objROLSegmentCollection;
		addSegment(EnumSegments.HL7_SEG_ROL_PATIENT_IDENTIFICATION, (ISingleCollection<ISegment>)objSegmentCollection);
	}

	/**
	 * Retrieves Collection of Role Segment(ROL) present in this message.
	 * @return ISingleCollection<ROL> - Collection of Role Segment(ROL) present in this message.
	 */
	@SuppressWarnings("unchecked")
	public ISingleCollection<ROL> getPatientIdentificationRoleSegments()
	{
		ISingleCollection<?> objSegmentCollection = getSegment(EnumSegments.HL7_SEG_ROL_PATIENT_IDENTIFICATION);
		return (ISingleCollection<ROL>)objSegmentCollection;
	}

	/**
	 * Adds Next of Kin/Associated Parties Segment(NK1) to this message.
	 * @param objNK1 Specified Next of Kin/Associated Parties Segment(NK1) to add in message.
	 */
	public void addNextOfKinOrAssociatedPartiesSegment(NK1 objNK1)
	{
		addSegment(EnumSegments.HL7_SEG_NK1, objNK1);
	}

	/**
	 * Adds collection of Role Segments(ROL) to this message.
	 * @param objNK1SegmentCollection Collection of Next of Kin/Associated Parties Segment(NK1) to add in this message
	 */
	@SuppressWarnings("unchecked")
	public void addNextOfKinOrAssociatedPartiesSegment(ISingleCollection<NK1>  objNK1SegmentCollection)
	{
		ISingleCollection<?> objSegmentCollection =  objNK1SegmentCollection;
		addSegment(EnumSegments.HL7_SEG_NK1, (ISingleCollection<ISegment>)objSegmentCollection);
	}

	/**
	 * Retrieves Collection of Next of Kin/Associated Parties Segment(NK1) present in this message.
	 * @return ISingleCollection<NK1> - Collection of Next of Kin/Associated Parties Segment(NK1) present in this message.
	 */
	@SuppressWarnings("unchecked")
	public ISingleCollection<NK1> getNextOfKinOrAssociatedPartiesSegments()
	{
		ISingleCollection<?> objSegmentCollection = getSegment(EnumSegments.HL7_SEG_NK1);
		return (ISingleCollection<NK1>)objSegmentCollection;
	}

	/**
	 * Retrieves Patient Visit(PV1) segment present in this message
	 * @return PV1 - Specified PV1 Segment
	 */
	public PV1 getPatientVisitSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_PV1);
		if(objSingleCollection != null)
			return (PV1)objSingleCollection.elementAt(0);
		return null;
	}

	/**
	 * Sets value of Patient Visit segment for this message,overwrites if already present.
	 * @param objPV1 Specified PV1 Segment
	 */
	public void setPatientVisitSegment(PV1 objPV1)
	{
		setSegment(EnumSegments.HL7_SEG_PV1,objPV1);
	}

	/**
	 * Retrieves Patient Visit Additional Info(PV2) segment present in this message.
	 * @return PV2 - Specified Patient Visit Additional Info(PV2) Segment
	 */
	public PV2 getPatientVisitAdditionalInfoSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_PV2);
		if(objSingleCollection != null)
			return (PV2)objSingleCollection.elementAt(0);
		return null;
	}
	/**
	 * Sets value of Patient Visit Additional Info(PV2) segment for this message,overwrites if already present.
	 * @param objPV2 Specified PV2 Segment
	 */
	public void setPatientVisitAdditionalInfoSegment(PV2 objPV2)
	{
		setSegment(EnumSegments.HL7_SEG_PV2,objPV2);
	}

	/**
	 * Adds Access Restrictions(ARV) to this message.
	 * @param objARV Specified Access Restrictions Segment to be added in message.
	 */
	public void addPatientVisitAccessRestrictionsSegment(ARV objARV)
	{
		addSegment(EnumSegments.HL7_SEG_ARV_PATIENT_VISIT, objARV);
	}

	/**
	 * Adds collection of Access Restrictions(ARV) to this message.
	 * @param objARVSegmentCollection Collection of Access Restrictions(ARV) to add in this message
	 */
	@SuppressWarnings("unchecked")
	public void addPatientVisitAccessRestrictionsSegments(ISingleCollection<ARV>  objARVSegmentCollection)
	{
		ISingleCollection<?> objSegmentCollection =  objARVSegmentCollection;
		addSegment(EnumSegments.HL7_SEG_ARV_PATIENT_VISIT, (ISingleCollection<ISegment>)objSegmentCollection);
	}

	/**
	 * Retrieves Collection of Access Restrictions(ARV) present in this message.
	 * @return ISingleCollection<ARV> - Collection of Access Restrictions(ARV) present in this message.
	 */
	@SuppressWarnings("unchecked")
	public ISingleCollection<ARV> getPatientVisitAccessRestrictionsSegments()
	{
		ISingleCollection<?> objSegmentCollection = getSegment(EnumSegments.HL7_SEG_ARV_PATIENT_VISIT);
		return (ISingleCollection<ARV>)objSegmentCollection;
	}
	
	
	
	/**
	 * Adds Role Segment(ROL) to this message.
	 * @param objROL Specified Role Segment to be added in message.
	 */
	public void addPatientVisitRoleSegment(ROL objROL)
	{
		addSegment(EnumSegments.HL7_SEG_ROL_PATIENT_VISIT, objROL);
	}

	/**
	 * Adds collection of Role Segments(ROL) to this message.
	 * @param objROLSegmentCollection Collection of Role Segment(ROL) to add in this message
	 */
	@SuppressWarnings("unchecked")
	public void addPatientVisitRoleSegment(ISingleCollection<ROL>  objROLSegmentCollection)
	{
		ISingleCollection<?> objSegmentCollection =  objROLSegmentCollection;
		addSegment(EnumSegments.HL7_SEG_ROL_PATIENT_VISIT, (ISingleCollection<ISegment>)objSegmentCollection);
	}

	/**
	 * Retrieves Collection of Role Segment(ROL) present in this message.
	 * @return ISingleCollection<ROL> - Collection of Role Segment(ROL) present in this message.
	 */
	@SuppressWarnings("unchecked")
	public ISingleCollection<ROL> getPatientVisitRoleSegments()
	{
		ISingleCollection<?> objSegmentCollection = getSegment(EnumSegments.HL7_SEG_ROL_PATIENT_VISIT);
		return (ISingleCollection<ROL>)objSegmentCollection;
	}

	/**
	 * Adds Disability Information(DB1) to this message.
	 * @param objDB1 Specified Disability Information Segment to be added in message.
	 */
	public void addDisabilityInformationSegment(DB1 objDB1)
	{
		addSegment(EnumSegments.HL7_SEG_DB1, objDB1);
	}

	/**
	 * Adds collection of Disability Information(DB1) to this message.
	 * @param objDB1SegmentCollection Collection of Disability Information(DB1) segment to add in this message
	 */
	@SuppressWarnings("unchecked")
	public void addDisabilityInformationSegment(ISingleCollection<DB1>  objDB1SegmentCollection)
	{
		ISingleCollection<?> objSegmentCollection =  objDB1SegmentCollection;
		addSegment(EnumSegments.HL7_SEG_DB1, (ISingleCollection<ISegment>)objSegmentCollection);
	}

	/**
	 * Retrieves Collection of Disability Information(DB1) present in this message.
	 * @return ISingleCollection<DB1> - Collection of Disability Information(DB1) segment present in this message.
	 */
	@SuppressWarnings("unchecked")
	public ISingleCollection<DB1> getDisabilityInformationSegments()
	{
		ISingleCollection<?> objSegmentCollection = getSegment(EnumSegments.HL7_SEG_DB1);
		return (ISingleCollection<DB1>)objSegmentCollection;
	}

	/**
	 * Adds Observation Or Result(OBX) to this message.
	 * @param objOBX Specified Observation Or Result Segment to be added in message.
	 */
	public void addObservationOrResultSegment(OBX objOBX)
	{
		addSegment(EnumSegments.HL7_SEG_OBX, objOBX);
	}

	/**
	 * Adds collection of Observation Or Result(OBX) to this message.
	 * @param objOBXSegmentCollection Collection of Observation Or Result(OBX) to add in this message
	 */
	@SuppressWarnings("unchecked")
	public void addObservationOrResultSegment(ISingleCollection<OBX>  objOBXSegmentCollection)
	{
		ISingleCollection<?> objSegmentCollection =  objOBXSegmentCollection;
		addSegment(EnumSegments.HL7_SEG_OBX, (ISingleCollection<ISegment>)objSegmentCollection);
	}

	/**
	 * Retrieves Collection of Observation Or Result(OBX) present in this message.
	 * @return ISingleCollection<OBX> - Collection of Observation Or Result(OBX) present in this message.
	 */
	@SuppressWarnings("unchecked")
	public ISingleCollection<OBX> getObservationOrResultSegments()
	{
		ISingleCollection<?> objSegmentCollection = getSegment(EnumSegments.HL7_SEG_OBX);
		return (ISingleCollection<OBX>)objSegmentCollection;
	}

	/**
	 * Adds Allergy Information(AL1) to this message.
	 * @param objAL1 Specified Allergy Information(AL1) Segment to be added in message.
	 */
	public void addAllergyInformationSegment(AL1 objAL1)
	{
		addSegment(EnumSegments.HL7_SEG_AL1, objAL1);
	}

	/**
	 * Adds collection of Allergy Information(AL1) to this message.
	 * @param objAL1SegmentCollection Collection of Allergy Information(AL1) to add in this message
	 */
	@SuppressWarnings("unchecked")
	public void addAllergyInformationSegment(ISingleCollection<AL1>  objAL1SegmentCollection)
	{
		ISingleCollection<?> objSegmentCollection =  objAL1SegmentCollection;
		addSegment(EnumSegments.HL7_SEG_AL1, (ISingleCollection<ISegment>)objSegmentCollection);
	}

	/**
	 * Retrieves Collection of Allergy Information(AL1) present in this message.
	 * @return ISingleCollection<AL1> - Collection of Allergy Information(AL1) present in this message.
	 */
	@SuppressWarnings("unchecked")
	public ISingleCollection<AL1> getAllergyInformationSegments()
	{
		ISingleCollection<?> objSegmentCollection = getSegment(EnumSegments.HL7_SEG_AL1);
		return (ISingleCollection<AL1>)objSegmentCollection;
	}

	/**
	 * Adds Diagnosis Information(DG1) to this message.
	 * @param objDG1 Specified Diagnosis Information(DG1) Segment to this message.
	 */
	public void addDiagnosisInformationSegment(DG1 objDG1)
	{
		addSegment(EnumSegments.HL7_SEG_DG1, objDG1);
	}

	/**
	 * Adds collection of Diagnosis Information(DG1) to this message.
	 * @param objDG1SegmentCollection Collection of Diagnosis Information(DG1)segments to add in this message
	 */
	@SuppressWarnings("unchecked")
	public void addDiagnosisInformationSegment(ISingleCollection<DG1>  objDG1SegmentCollection)
	{
		ISingleCollection<?> objSegmentCollection =  objDG1SegmentCollection;
		addSegment(EnumSegments.HL7_SEG_DG1, (ISingleCollection<ISegment>)objSegmentCollection);
	}

	/**
	 * Retrieves Collection of Diagnosis Information(DG1) present in this message.
	 * @return ISingleCollection<DG1> - Collection of Diagnosis Information(DG1) segments present in this message.
	 */
	@SuppressWarnings("unchecked")
	public ISingleCollection<DG1> getDiagnosisInformationSegments()
	{
		ISingleCollection<?> objSegmentCollection = getSegment(EnumSegments.HL7_SEG_DG1);
		return (ISingleCollection<DG1>)objSegmentCollection;
	}

	/**
	 * Retrieves Diagnosis Related Group segment(DRG) present in this message.
	 * @return DRG - Specified Diagnosis Related Group(DRG) Segment.
	 */
	public DRG getDiagnosisRelatedGroupSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_DRG);
		if(objSingleCollection != null)
			return (DRG)objSingleCollection.elementAt(0);
		return null;
	}

	/**
	 * Sets value of Diagnosis Related Group segment(DRG) for this message,overwrites if already present.
	 * @param objDRG Specified Diagnosis Related Group(DRG) Segment.
	 */
	public void setDiagnosisRelatedGroupSegment(DRG objDRG)
	{
		setSegment(EnumSegments.HL7_SEG_DRG,objDRG);
	}

	/**
	 * Retrieves Accident Information segment(ACC) present in this message.
	 * @return ACC - Specified Accident Information(ACC) Segment.
	 */
	public ACC getAccidentInformationSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_ACC);
		if(objSingleCollection != null)
			return (ACC)objSingleCollection.elementAt(0);
		return null;
	}

	/**
	 * Sets value of Accident Information segment(ACC) for this message,overwrites if already present.
	 * @param objACC Specified Accident Information(ACC) Segment.
	 */
	public void setAccidentInformationSegment(ACC objACC)
	{
		setSegment(EnumSegments.HL7_SEG_ACC,objACC);
	}

	
	//**************************
	/**
	 * Retrieves Universal Bill Information segment(UB1) present in this message.
	 * @return UB1 - Specified Universal Bill Information(UB1) Segment.
	 */
	
	
/*	public UB1 getUniversalBillInformationSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_UB1);
		if(objSingleCollection != null)
			return (UB1)objSingleCollection.elementAt(0);
		return null;
	}

	*//**
	 * Sets value of Universal Bill Information segment(UB1) for this message,overwrites if already present.
	 * @param objUB1 Specified Universal Bill Information(UB1) Segment.
	 *//*
	public void setUniversalBillInformationSegment(UB1 objUB1)
	{
		setSegment(EnumSegments.HL7_SEG_UB1,objUB1);
	}*/
	//************************
	
	
	/**
	 * Adds Guarantor(GT1) to this message.
	 * @param objGT1 Specified Guarantor Segment to this message.
	 */
	public void addGuarantorSegment(GT1 objGT1)
	{
		addSegment(EnumSegments.HL7_SEG_GT1, objGT1);
	}

	/**
	 * Adds collection of Guarantor(GT1) to this message.
	 * @param objGT1SegmentCollection Collection of Guarantor(GT1) to add in this message
	 */
	@SuppressWarnings("unchecked")
	public void addGuarantorSegment(ISingleCollection<GT1>  objGT1SegmentCollection)
	{
		ISingleCollection<?> objSegmentCollection =  objGT1SegmentCollection;
		addSegment(EnumSegments.HL7_SEG_GT1, (ISingleCollection<ISegment>)objSegmentCollection);
	}

	/**
	 * Retrieves Collection of Guarantor(GT1) present in this message.
	 * @return ISingleCollection<GT1> - Collection of Guarantor(GT1) present in this message.
	 */
	@SuppressWarnings("unchecked")
	public ISingleCollection<GT1> getGuarantorSegments()
	{
		ISingleCollection<?> objSegmentCollection = getSegment(EnumSegments.HL7_SEG_GT1);
		return (ISingleCollection<GT1>)objSegmentCollection;
	}

	/**
	 * Retrieves Universal Bill 92 Information segment(UB2) present in this message.
	 * @return UB2 - Universal Bill 92 Information(UB2) Segment.
	 */
	public UB2 getUniversalBill92InformationSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_UB2);
		if(objSingleCollection != null)
			return (UB2)objSingleCollection.elementAt(0);
		return null;
	}

	/**
	 * Sets value of Universal Bill 92 Information segment(UB2) for this message,overwrites if already present.
	 * @param objUB2 Specified Universal Bill 92 Information(UB2) Segment.
	 */
	public void setUniversalBill92InformationSegment(UB2 objUB2)
	{
		setSegment(EnumSegments.HL7_SEG_UB2,objUB2);
	}

	/**
	 * Retrieves Patient Death and Autopsy segment(PDA) present in this message.
	 * @return PDA - Patient Death and Autopsy(PDA) Segment.
	 */
	public PDA getPatientDeathandAutopsySegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_PDA);
		if(objSingleCollection != null)
			return (PDA)objSingleCollection.elementAt(0);
		return null;
	}

	/**
	 * Sets value of Patient Death and Autopsy segment(PDA) for this message,overwrites if already present.
	 * @param objPDA Specified Patient Death and Autopsy(PDA) Segment.
	 */
	public void setPatientDeathandAutopsySegment(PDA objPDA)
	{
		setSegment(EnumSegments.HL7_SEG_PDA,objPDA);
	}

	/**
	 * Retrieves Collection of PROCEDURE GROUP present in this message.
	 * @return ISingleCollection<Group> - Collection of PROCEDURE Group present in this Message.
	 */
	public ISingleCollection<IGroup> getProcedureGroups()
	{
		return getGroup(EnumSegments.HL7_GROUP_PROCEDURE);
	}

	/**
	 * Adds Collection of PROCEDURE GROUP to this message.
	 * @param objSingleCollection - Specified PROCEDURE GROUP Collection.
	 */
	public void addProcedureGroups(ISingleCollection<IGroup> objSingleCollection)
	{
		addGroup(EnumSegments.HL7_GROUP_PROCEDURE, objSingleCollection);
	}

	/**
	 * Adds PROCEDURE GROUP to this message.
	 * @param objGroup Specified PROCEDURE GROUP.
	 */
	public void addProcedureGroup(IGroup objGroup)
	{
		addGroup(EnumSegments.HL7_GROUP_PROCEDURE, objGroup);
	}

	/**
	 * Retrieves Collection of INSURANCE GROUP present in this message.
	 * @return ISingleCollection<Group> - Collection of INSURANCE Group present in this Message.
	 */
	public ISingleCollection<IGroup> getInsuranceGroups()
	{
		return getGroup(EnumSegments.HL7_GROUP_INSURANCE);
	}

	/**
	 * Adds Collection of INSURANCE GROUP to this message.
	 * @param objSingleCollection - Specified INSURANCE GROUP Collection.
	 */
	public void addInsuranceGroups(ISingleCollection<IGroup> objSingleCollection)
	{
		addGroup(EnumSegments.HL7_GROUP_INSURANCE, objSingleCollection);
	}

	/**
	 * Adds INSURANCE GROUP to this message.
	 * @param objGroup Specified INSURANCE GROUP.
	 */
	public void addInsuranceGroup(IGroup objGroup)
	{
		addGroup(EnumSegments.HL7_GROUP_INSURANCE, objGroup);
	}
}
